#
# pushare - P2P file shareing
#
# Copyright (c) 2004 Satoshi Fukutomi <fuktommy@inter7.jp>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Neither the name of the University nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: Config.pm,v 1.7 2004/12/17 15:56:48 fuktommy Exp $
#

package PuShare::Config;
use strict;
no strict "vars";

$port		= 8008;
$adminAddr	= "^127";			# regxp
@initNode	= qw(
	fuktommy.ddo.jp:8008
);

$cachedir	= "./cache";
$updir		= "./up";
$okdir		= "./ok";
$downdir	= "./down";
$workdir	= "./work";
$lock		= "$workdir/lock.txt";
$client		= "$workdir/client.txt";
$nodelist	= "$workdir/node.txt";
$distlist	= "$workdir/dist.txt";
$ignorelist	= "$workdir/ignore.txt";
$searchlist	= "$workdir/search.txt";
$namelist	= "$workdir/name.txt";
$jcode		= "euc";

$timeout	= 30;		# seconds
$timeError	= 60;		# seconds
$clientfrec	= 5;		# minutes
$pingfrec	= 11;		# minutes
$initfrec	= 25;		# minutes
$joinfrec	= 14;		# minutes
$distfrec	= 60;		# minutes
$timeout_client = 10;		# minutes	($timeout_client < $distfrec)
$savedist	= 180;		# minutes
$relay		= 0.1;		# probability
$ignore		= 0.1;		# probability
$bufsize	= 8192;		# bytes
$retry		= 3;		# times
$retrySearch	= 3;		# times
$nodes		= 5;
$children	= 10;
$version	= "0.1-beta7";

%command  = (
	md5sum => "md5sum",
	cp     => "cp",
	mv     => "mv",
);

if ($^O eq "freebsd") {
	$command{md5sum}   = "md5";
} elsif ($^O eq "cygwin") {
	$jcode = "sjis";
}

%mimeType = qw (
	avi	video/x-msvideo
	bin	application/octet-stream
	bmp	image/bmp
	cpio	application/x-cpio
	csv	text/comma-separated-values
	dvi	application/x-dvi
	gif	image/gif
	html	text/html
	jar	application/x-java-archive
	jpg	image/jpeg
	lzh	application/x-lzh
	mid	audio/midi
	mov	video/quicktime
	mp3	audio/mpeg
	mpg	video/mpeg
	ogg	application/x-ogg
	pdf	application/pdf
	pgp	application/pgp-signature
	png	image/png
	ps	application/postscript
	ra	audio/x-realaudio
	rpm	application/x-redhat-package-manager
	swf	application/x-shockwave-flash
	tar	application/x-tar
	tex	application/x-tex
	tif	image/tiff
	txt	text/plain
	tgz	application/x-gtar
	wav	audio/x-wav
	xml	text/xml
	zip	application/zip
);

1;
